-- See the Copyright notice at the end of this file.
--
class QUOTED_PRINTABLE_OUTPUT_STREAM
	--
	-- A quoted-printable encoder. The underlying stream gets encoded in quoted-printable via this filter.
	--

inherit
	FILTER_OUTPUT_STREAM

creation {ANY}
	connect_to

feature {}
   local_can_disconnect: BOOLEAN is True

feature {FILTER_OUTPUT_STREAM}
	filtered_put_character (c: CHARACTER) is
		do
			inspect
				c.code
			when 0 .. 9, 11 .. 31, 128 .. 255 then
				put_quoted_character(c)
			else
				stream.filtered_put_character(c)
			end
		end

	filtered_flush is
		do
			stream.filtered_flush
		end

feature {}
	put_quoted_character (c: CHARACTER) is
		local
			s: STRING
		do
			s := once ""
			s.clear
			c.code.to_hexadecimal_in(s)
			stream.filtered_put_character('=')
			stream.filtered_put_character(s.item(s.upper - 1))
			stream.filtered_put_character(s.last)
		end

end -- class QUOTED_PRINTABLE_OUTPUT_STREAM
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
