-- See the Copyright notice at the end of this file.
--
class NULL_INPUT_STREAM
	--
	-- This "null" stream provides an unbroken sequence of '%U'
	-- (like /dev/zero does on Unix)
	--

inherit
	TERMINAL_INPUT_STREAM
		redefine filtered_read_line_in
		end

feature {ANY}
	end_of_input: BOOLEAN is False

	is_connected: BOOLEAN is True

	can_unread_character: BOOLEAN is True

	disconnect is
		do
			filter := Void
		end

feature {FILTER_INPUT_STREAM}
	filtered_read_character is
		do
		end

	filtered_unread_character is
		do
		end

	filtered_last_character: CHARACTER is '%U'

	filtered_read_line_in (buffer: STRING) is
		do
		end

feature {FILTER}
   filtered_descriptor: INTEGER is
      do
      end

   filtered_has_descriptor: BOOLEAN is False

end -- class NULL_INPUT_STREAM
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
