-- See the Copyright notice at the end of this file.
--
class ITERATOR_ON_COLLECTION[E]
	-- Please do not use this class directly. Look at `ITERATOR'.

inherit
	ITERATOR[E]

creation {ANY}
	make

feature {}
	collection: COLLECTION[E]
			-- The one to be traversed.

	item_index: INTEGER
			--  Memorize the current position.

feature {ANY}
	make (c: COLLECTION[E]) is
		require
			c /= Void
		do
			collection := c
			item_index := collection.lower
		ensure
			collection = c
		end

	start is
		do
			item_index := collection.lower
		end

	is_off: BOOLEAN is
		do
			Result := not collection.valid_index(item_index)
		end

	item: E is
		do
			Result := collection.item(item_index)
		end

	next is
		do
			item_index := item_index + 1
		end

end -- class ITERATOR_ON_COLLECTION
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
