-- See the Copyright notice at the end of this file.
--
class FUNCTION[B_, O_ -> TUPLE, R_]
	--
	-- Where B is the base type (i.e. a type of compatible with the target of the delayed call) and where O represents open
	-- arguments (i.e. arguments which are delayed) and where R is for the result type of the delayed call.
	--

inherit
	ROUTINE[ANY, O_]

feature {ANY}
	item (o: O_): R_ is
			-- Result of calling feature with all its operands, using `o' for the open operands.
		external "built_in"
		end

end -- class FUNCTION
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
