class HOST

inherit
   ADDRESS

insert
   SOCKET_PLUG_IN

creation {ANY}
   make

feature {ANY}
   hostname: STRING

   server: SOCKET_SERVER is
      do
         if resolved = Void then
            resolve
         end
         Result := resolved.server
      end

   hash_code: INTEGER is
      do
         if resolved = Void then
            resolve
         end
         Result := resolved.hash_code
      end

feature {SOCKET_HANDLER}
   socket: SOCKET is
      do
         if resolved = Void then
            resolve
         end
         Result := resolved.socket
      end

feature {}
   resolved: IP_ADDRESS

   resolve is
      require
         resolved = Void
      local
         a, b, c, d, ip: INTEGER
      do
         ip := net_hostname(hostname.to_external)
         a := (ip |>>> 24)
         b := ((ip |>>> 16) & 0x000000ff)
         c := ((ip |>>> 8) & 0x000000ff)
         d := (ip & 0x000000ff)
         create resolved.make(a, b, c, d, access)
      ensure
         last_error = Void
         resolved /= Void
      end

feature {}
   make (a_hostname: STRING; a_access: ACCESS) is
      require
         a_hostname /= Void
         a_access /= Void
      do
         hostname := a_hostname
         access := a_access
      end

end
