class IP_ADDRESS

inherit
   ADDRESS

creation {ANY}
   make

feature {ANY}
   a, b, c, d: INTEGER

   server: SOCKET_SERVER is
      do
         if server_memory = Void then
            create server_memory.make(a, b, c, d, access)
         end
         Result := server_memory
      end

   hash_code: INTEGER is
      do
         Result := (a |<< 24) | (b |<< 16) | (c |<< 8) | d
      end

feature {SOCKET_HANDLER}
   socket: SOCKET is
      do
         create Result.make(a, b, c, d)
         access.connect_socket(Result)
      end

feature {}
   make (ip_a, ip_b, ip_c, ip_d: INTEGER; a_access: ACCESS) is
      require
         a_access /= Void
      do
         a := ip_a
         b := ip_b
         c := ip_c
         d := ip_d
         access := a_access
      end

   server_memory: SOCKET_SERVER

end
