class SOCKET_PLUG_IN

feature {}
   last_error: STRING is
      local
         e: POINTER
      do
         e := net_last_error
         if e /= default_pointer then
            Result := last_error_memory
            Result.from_external(e)
         end
      end

   last_error_memory: STRING is ""

feature {} -- Plugin
   net_tcp (ip_a, ip_b, ip_c, ip_d: INTEGER; a_port: INTEGER): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_tcp"
         }"
      end

   net_udp (ip_a, ip_b, ip_c, ip_d: INTEGER; a_port: INTEGER): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_udp"
         }"
      end

   net_local (a_port: INTEGER): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_local"
         }"
      end

   net_select (a_fd: INTEGER; a_timeout: REAL): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_select_one"
         }"
      end

   net_read (a_fd, a_count: INTEGER; a_buffer: NATIVE_ARRAY[CHARACTER]): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_read"
         }"
      end

   net_write (a_fd, a_count: INTEGER; a_buffer: NATIVE_ARRAY[CHARACTER]): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_write"
         }"
      end

   net_accept (a_fd: INTEGER; a_val: NATIVE_ARRAY[INTEGER]) is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_accept"
         }"
      end

   net_disconnect (a_fd: INTEGER) is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_disconnect"
         }"
      end

   net_last_error: POINTER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_last_error"
         }"
      end

   net_last_error_number: INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_last_error_number"
         }"
      end

   net_hostname(a_hostname: POINTER): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_hostname"
         }"
      end

   net_tcp_server(port: INTEGER): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_tcp_server"
         }"
      end

   net_udp_server(port: INTEGER): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_udp_server"
         }"
      end

   net_local_server(port: INTEGER): INTEGER is
      external "plug_in"
      alias "{
         location: "${sys}/runtime"
         module_name: "net"
         feature_name: "net_local_server"
         }"
      end

end
