-- See the Copyright notice at the end of this file.
--
expanded class REAL_32
--
-- 32 bits floating point.
--

inherit
	REAL_GENERAL

feature {ANY} -- Conversions:
	to_real_64, to_real: REAL_64 is
			-- Explicit conversion to REAL_64.
		do
			Result := Current
		ensure
			Current = Result
		end

	to_real_extended: REAL_EXTENDED is
			-- Explicit conversion to REAL_EXTENDED.
		do
			Result := Current
		ensure
			Current = Result
		end

	to_real_80: REAL_80 is
			-- Explicit conversion to REAL_80.
		do
			Result := Current
		ensure
			Current = Result
		end

	to_real_128: REAL_128 is
			-- Explicit conversion to REAL_128.
		do
			Result := Current
		ensure
			Current = Result
		end

	force_to_integer_32: INTEGER_32 is
		external "built_in"
		end

	force_to_integer_64: INTEGER_64 is
		external "built_in"
		end

feature {ANY}
	zero: REAL_32 is {REAL_32 0.0 }
	
	one: REAL_32 is {REAL_32 1.0 }

	hash_code: INTEGER is
		do
			Result := force_to_integer_32
			if Result < 0 then
				Result := - (Result + 1)
			end
		end
	
feature {}
	sprintf (buffer: NATIVE_ARRAY[CHARACTER]; mode: CHARACTER; f: INTEGER; value: REAL_64) is
		external "plug_in"
		alias "{
			location: "${sys}runtime"
			module_name: "basic_sprintf"
			feature_name: "sprintf_real_64"
			}"
		end

end -- class REAL_32
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------

