-- See the Copyright notice at the end of this file.
--
class DOUBLE_HASHED_DICTIONARY[V -> HASHABLE, K -> HASHABLE]

inherit
	DOUBLE_DICTIONARY[V, K]
		redefine right, reverse, copy
		end

creation {ANY}
	make, with_capacity

feature {ANY}
	copy (other: like Current) is
		do
			if right = Void then
				right := other.right.twin
			else
				right.copy(other.right)
			end
			if reverse = Void then
				reverse := other.reverse.twin
			else
				reverse.copy(other.reverse)
			end
		end

feature {DOUBLE_HASHED_DICTIONARY}
	right: HASHED_DICTIONARY[V, K]

	reverse: HASHED_DICTIONARY[K, V]

feature {}
	make is
		do
			create right.make
			create reverse.make
		end

	with_capacity (medium_size: INTEGER) is
		do
			create right.with_capacity(medium_size)
			create reverse.with_capacity(medium_size)
		end

end -- class DOUBLE_HASHED_DICTIONARY
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
