-- See the Copyright notice at the end of this file.
--
class HASHED_DICTIONARY_NODE[V, K -> HASHABLE]
	--
	-- Auxilliary class to implement HASHED_DICTIONARY[V,K->HASHABLE].
	--

inherit
	ANY_HASHED_DICTIONARY_NODE

creation {HASHED_DICTIONARY}
	make

feature {HASHED_DICTIONARY}
	item: V

	key: K

	next: like Current
			-- The `next' one when some clash occurs.

	set_item (i: like item) is
		do
			item := i
		ensure
			item = i
		end

	set_next (n: like next) is
		do
			next := n
		ensure
			next = n
		end

	make (i: like item; k: like key; n: like next) is
		do
			item := i
			key := k
			next := n
		ensure
			item = i
			key = k
			next = n
		end

end -- class HASHED_DICTIONARY_NODE
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
