-- See the Copyright notice at the end of this file.
--
deferred class LINKED_COLLECTION[E]
	--
	-- Common root of LINKED_LIST and TWO_WAY_LINKED_LIST.
	--

inherit
	COLLECTION[E]

feature {ANY}
	lower: INTEGER is 1
			-- Lower index bound is frozen.

	upper: INTEGER
			-- Memorized upper index bound.

feature {ANY}
	make is
			-- Make an empty list
		deferred
		end
	
feature {}
	-- Implement manifest generic creation.

	manifest_make (needed_capacity: INTEGER) is
			-- Manifest creation of a list of items of type E.
		do
			make
		end
	
	manifest_put (index: INTEGER; element: like item) is
		do
			add_last(element)
		end
	
end -- class LINKED_COLLECTION
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
