-- See the Copyright notice at the end of this file.
--
class QUEUE[E]
	--
	-- A Queue of elements of type `E'.
	--
	
insert
	RING_ARRAY[E]
		rename
			add as collection_add,
			add_last as add,
			remove as collection_remove,
			remove_first as remove,
			make as collection_make,
			manifest_make as collection_manifest_make
		export
			{ANY} is_empty, is_equal, copy, add, remove, first, count;
			{QUEUE} all;
		redefine
			get_new_iterator
		end

creation
	make

creation {RING_ARRAY}
	collection_make

feature {}
	make is
		do
			with_capacity(16, 1)
		ensure
			is_empty
		end

	get_new_iterator: ITERATOR[E] is
		do
			check
				False
			end
		end
	
	manifest_make (needed_capacity: INTEGER) is
			-- Create a QUEUE[E]
		do
			with_capacity(needed_capacity, 1)
		end
	
end -- class QUEUE
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
