-- See the Copyright notice at the end of this file.
--
expanded class CLOCK
--
-- Time and date facilities: year, month, day, hour and seconds.
--

feature {ANY}
	value: INTEGER is
			-- Get the CPU clock periods if available (-1 if not).
		do
			Result := basic_clock
		end
	
	periods_per_second: INTEGER is
			--  The number of clock periods per seconds.
		require
			value >= 0
		do
			Result := basic_clock_per_sec
		end
	
feature {}
	basic_clock: INTEGER is
		external "plug_in"
		alias "{
			location: "${sys}runtime"
			module_name: "basic_clock"
			feature_name: "basic_clock"
			}"
		end
	
	basic_clock_per_sec: INTEGER is
		external "plug_in"
		alias "{
			location: "${sys}runtime"
			module_name: "basic_clock"
			feature_name: "basic_clock_per_sec"
			}"
		end

end -- class CLOCK
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
