-- See the Copyright notice at the end of this file.
--
deferred class ALIGNABLE
	-- Helper class to write alignable variant. See for example LABEL_ALIGNABLE
	-- Alignment is useful only if x_expand_allowed or y_expand_allowed
	-- is `True' and the space given to the object is bigger than it's
	-- standard size.

inherit
	WIDGET

feature {ANY}
	alignment: ALIGNMENT

	set_alignment (a: ALIGNMENT) is
			-- x_expand_allowed and y_expand_allowed are set to `True' if
			-- previous alignment was `Void'
		do
			if alignment = Void then
				set_x_expand(True)
				set_y_expand(True)
			end
			alignment := a
		end

feature {}
	adjust_pos is
		do
			if alignment /= Void then
				pos_x := pos_x + ((width - std_width) * alignment.x).force_to_integer_32
				pos_y := pos_y + ((height - std_height) * alignment.y).force_to_integer_32
			end
		end

end -- class ALIGNABLE
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
