-- See the Copyright notice at the end of this file.
--
class ALIGNMENT
	-- This class is used to describe widget position inside area
	-- choosen by the container's layout.
	-- x is in range 0.0 to 1.0 from left to right (0.5 is the middle)
	-- y is in range 0.0 to 1.0 from top to bottom (0.5 is the middle)
	-- Alignment is useful only if x_expand_allowed or y_expand_allowed
	-- is `True' and the space given to the object is bigger than it's
	-- standard size.

inherit
	ANY
		redefine default_create
		end

creation {ANY}
	default_create, make

feature {ANY}
	x: REAL

	y: REAL

	default_create is -- *** export {} ??? ***
		do
			x := 0.0
			y := 0.0
		end

	make (x_pos, y_pos: REAL) is
		do
			x := x_pos
			y := y_pos
		end

	left is
		do
			x := 0.0
		end

	right is
		do
			x := 1.0
		end

	top is
		do
			y := 0.0
		end

	bottom is
		do
			y := 1.0
		end

	horizontal_center is
		do
			x := 0.5
		end

	vertical_center is
		do
			y := 0.5
		end

invariant
	x.in_range(0.0, 1.0)

	y.in_range(0.0, 1.0)

end -- class ALIGNMENT
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
