-- See the Copyright notice at the end of this file.
--
class BUTTON

inherit
	GRAPHIC
		undefine default_create
		end
	SUB_WINDOW
		undefine set_state
		redefine make, update_decoration
		end
	WHEN_DOUBLE_CLICKED
		undefine default_create, set_state
		end

insert
	WHEN_MIDDLE_CLICKED
		undefine default_create
		end
	WHEN_RIGHT_CLICKED
		undefine default_create
		end

creation {ANY}
	make, with_label

feature {}
	make (p: like parent) is
		do
			Precursor(p)
			when_double_clicked_init
			when_middle_clicked_init
			when_right_clicked_init
			set_state_normal
			map
		end

	with_label (p: like parent; text: UNICODE_STRING) is
		local
			tmp: LABEL; lo: ROW_LAYOUT
		do
			make(p)
			create tmp.make(text)
			--tmp.set_alignment(center_alignment)
			child_attach(tmp)
			lo ?= layout
			lo.set_border(5)
			lo.set_spacing(5)
		end

feature {ANY}
	set_state (n: INTEGER) is
		do
			if state /= n then
				state := n
				renderer.draw_button(Current)
				clear_area(0, 0, width, height)
			end
		end

	update_decoration is
		do
			renderer.draw_button(Current)
		end
		-- border: BORDER
		--   set_border(b: like border) is
		--      do
		--         if border /= Void then
		--            layer_remove_child(1, border)
		--         end
		--         border := b
		--         if b /= Void then
		--            layer_add_child(1, b)
		--         end
		--      end

end -- class BUTTON
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
