-- See the Copyright notice at the end of this file.
--
class CHECK_BUTTON

inherit
	GRAPHIC
		undefine
			default_create
		end
	SUB_WINDOW
		redefine make, set_state, update_decoration
		end

creation {ANY}
	make, with_label

feature {}
	make (p: like parent) is
		do
			Precursor(p)
			set_background_color(white_color)
			child_attach(create {CHECK_SPACE})
			set_state_normal
			when_left_down(agent switch_state)
			map
		end

	with_label (p: like parent; text: UNICODE_STRING) is
		local
			tmp: LABEL; lo: ROW_LAYOUT
		do
			make(p)
			create tmp.make(text)
			--tmp.set_alignment(center_alignment)
			child_attach(tmp)
			lo ?= layout
			lo.set_border(5)
			lo.set_spacing(5)
		end

feature {ANY}
	selected: BOOLEAN is
		do
			Result := is_state_active
		end

	switch_state is
		do
			if is_state_normal then
				set_state_active
			elseif is_state_active then
				set_state_normal
			end
		end

	set_state (n: INTEGER) is
		local
			w: WIDGET
		do
			if state /= n then
				state := n
				w := child.first
				clear_area(w.pos_x, w.pos_y, w.width, w.height)
				if when_value_change_signal /= Void then
					when_value_change_signal.emit(selected)
				end
			end
		end

	update_decoration is
		local
			w: WIDGET
		do
			w := child.first
			clear_area(w.pos_x, w.pos_y, w.width, w.height)
		end

	when_value_change_signal: SIGNAL_1[BOOLEAN]

	when_value_change (p: PROCEDURE[ANY, TUPLE[BOOLEAN]]) is
		do
			if when_value_change_signal = Void then
				create when_value_change_signal.make
			end
			when_value_change_signal.connect(p)
		end

end -- class CHECK_BUTTON
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
