-- See the Copyright notice at the end of this file.
--
class COLOR

creation {ANY}
	like_rgb, like_rgb_8, like_rgb_16

feature {}
	like_rgb (r, g, b: REAL) is
		require
			r.in_range(0.0, 1.0)
			g.in_range(0.0, 1.0)
			b.in_range(0.0, 1.0)
		do
			red := (r * 65535).truncated_to_integer
			green := (g * 65535).truncated_to_integer
			blue := (b * 65535).truncated_to_integer
			storage := basic_vision_get_color($red, $green, $blue)
		end

	like_rgb_8 (r, g, b: INTEGER) is
		require
			r.in_range(0, 255)
			g.in_range(0, 255)
			b.in_range(0, 255)
		do
			red := r * 256
			green := g * 256
			blue := b * 256
			storage := basic_vision_get_color($red, $green, $blue)
		end

	like_rgb_16 (r, g, b: INTEGER) is
		require
			r.in_range(0, 65535)
			g.in_range(0, 65535)
			b.in_range(0, 65535)
		do
			red := r
			green := g
			blue := b
			storage := basic_vision_get_color($red, $green, $blue)
		end

feature {ANY}
	red: INTEGER

	green: INTEGER

	blue: INTEGER

feature {WINDOW, DRAW_STYLE}
	storage: POINTER

feature {}
	basic_vision_get_color (r, g, b: POINTER): POINTER is
		external "plug_in"
		alias "{
	 location: "${sys}runtime"
	 module_name: "basic_vision"
	 feature_name: "basic_vision_get_color"
	 }"
		end

invariant
	red.in_range(0, 65535)

	green.in_range(0, 65535)

	blue.in_range(0, 65535)

end -- class COLOR
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
