-- See the Copyright notice at the end of this file.
--
expanded class ARC

inherit
	ANY
		redefine is_equal, default_create, out
		end

creation {ANY}
	default_create

feature {ANY}
	default_create is
		do
			--io.put_string(once "new ARC!%N")
		end

	is_equal (other: like Current): BOOLEAN is
		do
			Result := other.x = x and then other.y = y and then other.width = width and then other.height = height and then other.angle1 = angle1 and then other.angle2 = angle2
		end

	out: STRING is
		do
			Result := out_buffer
			Result.clear
			Result.extend('(')
			x.append_in(Result)
			Result.extend(',')
			y.append_in(Result)
			Result.extend(' ')
			width.append_in(Result)
			Result.extend('x')
			height.append_in(Result)
			Result.extend(' ')
			(angle1.to_real_64 / 64.0).append_in(Result)
			Result.append(once " ")
			(angle2.to_real_64 / 64.0).append_in(Result)
			Result.append(once ")")
		end

feature {DECORATOR, ARC}
	set (x_, y_, width_, height_, angle1_, angle2_: INTEGER) is
		do
			if not storage.is_not_null then
				make_storage
			end
			basic_guikit_arc(to_external, x_, y_, width_, height_, angle1_, angle2_)
		end

	set_x (x_: INTEGER) is
		do
			set(x_, y, width, height, angle1, angle2)
		end

	set_y (y_: INTEGER) is
		do
			set(x, y_, width, height, angle1, angle2)
		end

	set_width (width_: INTEGER) is
		do
			set(x, y, width_, height, angle1, angle2)
		end

	set_height (height_: INTEGER) is
		do
			set(x, y, width, height_, angle1, angle2)
		end

	set_angle1 (angle1_: INTEGER) is
			-- angle in 64th of degree
		do
			set(x, y, width, height, angle1_, angle2)
		end

	set_angle2 (angle2_: INTEGER) is
			-- angle in 64th of degree
		do
			set(x, y, width, height, angle1, angle2_)
		end

	to_external: POINTER is
		do
			Result := storage.to_external
		end

	x: INTEGER is
		do
			--         Result := basic_guikit_arc_get_x(storage.to_external)
		end

	y: INTEGER is
		do
			--         Result := basic_guikit_arc_get_y(storage.to_external)
		end

	width: INTEGER is
		do
			--         Result := basic_guikit_arc_get_width(storage.to_external)
		end

	height: INTEGER is
		do
			--         Result := basic_guikit_arc_get_height(storage.to_external)
		end

	angle1: INTEGER is
			-- angle in 64th of degree
		do
			--         Result := basic_guikit_arc_get_angle1(storage.to_external)
		end

	angle2: INTEGER is
			-- angle in 64th of degree
		do
			--         Result := basic_guikit_arc_get_angle2(storage.to_external)
		end

feature {DECORATOR}
	export_data (store: like storage; index: INTEGER) is
		do
			store.copy_at(basic_guikit_arc_size * index, storage, basic_guikit_arc_size)
		end

feature {}
	storage: NATIVE_ARRAY[INTEGER_8]

	out_buffer: STRING is ""

	make_storage is
		do
			storage := storage.calloc(basic_guikit_arc_size)
		end

	basic_guikit_arc (store: POINTER; x_, y_, width_, height_, angle1_, angle2_: INTEGER) is
		external "plug_in"
		alias "{
	 location: "${sys}runtime"
	 module_name: "basic_guikit"
	 feature_name: "basic_guikit_arc"
	 }"
		end

	basic_guikit_arc_size: INTEGER is
		external "plug_in"
		alias "{
	 location: "${sys}runtime"
	 module_name: "basic_guikit"
	 feature_name: "basic_guikit_arc_size"
	 }"
		end

end -- class ARC
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
