-- See the Copyright notice at the end of this file.
--
class POINTER_STATUS

inherit
	SENSITIVE
insert
	WHEN_POINTER_ENTER
	WHEN_POINTER_LEAVE

feature {ANY}
	is_pointer_inside: BOOLEAN

feature {}
	pointer_status_init is
		do
			if not pointer_status_initialized then
				when_pointer_enter(agent private_pointer_in)
				when_pointer_leave(agent private_pointer_out)
				pointer_status_initialized := True
			end
		end

	private_pointer_in is
		do
			is_pointer_inside := True
		end

	private_pointer_out is
		do
			is_pointer_inside := False
		end

feature {}
	pointer_status_initialized: BOOLEAN

end -- class POINTER_STATUS
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
