-- See the Copyright notice at the end of this file.
--
class WHEN_MIDDLE_CLICKED

inherit
	POINTER_STATUS
insert	
	WHEN_MIDDLE_DOWN
	WHEN_MIDDLE_UP

feature {ANY}
	middle_click_signal: SIGNAL_0

	when_middle_clicked (p: PROCEDURE[ANY, TUPLE]) is
		do
			middle_click_signal.connect(p)
		end

	middle_is_down: BOOLEAN

feature {}
	when_middle_clicked_init is
		do
			pointer_status_init
			create middle_click_signal.make
			when_middle_down(agent private_middle_down)
			when_middle_up(agent private_middle_up)
			when_pointer_enter(agent private_middle_pointer_enter)
		end

	middle_may_click: BOOLEAN

	private_middle_down is
		do
			middle_is_down := True
			middle_may_click := True --paint(pos_x,pos_y)
		ensure
			middle_is_down
		end

	private_middle_up is
		require
			middle_is_down
		do
			if middle_may_click and then is_pointer_inside then
				middle_click_signal.emit
			end
			middle_is_down := False
			middle_may_click := False
		ensure
			not middle_is_down
		end

	private_middle_pointer_enter is
		do
			middle_is_down := vision.is_middle_down
		end

end -- class WHEN_MIDDLE_CLICKED
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
