-- See the Copyright notice at the end of this file.
--
class GRAPHIC_CONNECTION
	-- This internal class allow to see the graphic connection as a
	-- file who the sequencer has to wait data from.
	-- Some graphic program may wait data from multiple source (files)
	-- and wait for user requests (from the user interface) at the same time.
	-- See lib/sequencer for more details.

inherit
	INPUT_STREAM
		redefine descriptor
		end

creation {VISION}
	set_descriptor

feature {}
	set_descriptor (desc: INTEGER) is
		do
			descriptor := desc
		end

feature {FILTER}
	filtered_descriptor: INTEGER is
		do
			Result := descriptor
		end

	filtered_has_descriptor: BOOLEAN is
		do
			Result := descriptor /= 0
		end

feature {ANY}
	can_read_character, can_unread_character, can_read_line, valid_last_character: BOOLEAN is False

	end_of_input: BOOLEAN is True

	disconnect is
		do
			check
				False
			end
		end

feature {FILTER_INPUT_STREAM}
	filtered_read_character, filtered_unread_character is
		do
			check
				False
			end
		end

	filtered_last_character: CHARACTER is
		do
			check
				False
			end
		end

feature {ANY}
	descriptor: INTEGER

	can_disconnect: BOOLEAN is True
	
	is_connected: BOOLEAN is
		do
			Result := descriptor /= 0
		end

end -- class GRAPHIC_CONNECTION
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
