-- See the Copyright notice at the end of this file.
--
deferred class LINE
	-- Use line as widget (insert in container then position, draw and size
	-- are automatic). Common ancestor for `HORIZONTAL_LINE' and `VERTICAL_LINE'

inherit
	WIDGET
	DRAWABLE_HANDLER
	GRAPHIC
		--TODO: suppress ?

feature {ANY}
	width, height: INTEGER

	thickness: INTEGER

	style: DRAW_STYLE

	set_thickness (thick: INTEGER) is
			-- Set the thickness of the line (drawing' witdh)
		require
			thick > 0
		deferred
		ensure
			thick = thickness
		end

	set_style (s: DRAW_STYLE) is
			-- Change the style used to draw the line.
			-- NOTE: The screen is not updated. --TODO: change this ?
		do
			style := s
		ensure
			style = s
		end

	reset_default_style is
			-- The renderer will be used to draw the line.
			-- NOTE: The screen is not updated. --TODO: change this ?
		do
			style := Void
		end

feature {LAYOUT}
	set_geometry (x, y, w, h: INTEGER) is
		do
			pos_x := x
			pos_y := y
			width := w
			height := h
		end

feature {}
	resize (w, h: INTEGER) is
		do
			width := w
			height := h
		end

end -- class LINE
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
