-- See the Copyright notice at the end of this file.
--
class BASIC_RENDERER
	-- This renderer is designed for very simple and high speed rendering.
	-- It may be useful is the display goes through low bandwidth or high
	-- latency network.

inherit
	RENDERER
		redefine default_create
		end
	GRAPHIC
		redefine default_create
		end

creation {ANY}
	default_create

feature {} --avoir un pen pour chaque couleur... de type draw_style
	pen: DRAW_KIT

	pixmap: PIXMAP

	default_create is
		do
			create pen
			create pixmap.make(8, 8)
		end

feature {ANY}
	draw_line (d: DRAWABLE; x1, y1, x2, y2, state: INTEGER) is
		do
			pen.set_drawable(d)
			if state = state_insensitive then
				pen.set_color(color_gradient.item(14))
			else
				pen.set_color(color_gradient.item(0))
			end
			pen.line(x1, y1, x2, y2)
		end

	draw_button (b: BUTTON) is
		local
			color: INTEGER
		do
			inspect
				b.state
			when state_active then
				color := 12
			when state_normal then
				color := 14
			when state_prelight then
				color := 15
			end
			b.set_background_color(color_gradient.item(color))
			-- 	 inspect b.state
			-- 	 when state_active then draw_box(pixmap, 0, 0, 8, 8, 12)
			-- 	 when state_normal then draw_box(pixmap, 0, 0, 8, 8, 14)
			-- 	 when state_prelight then draw_box(pixmap, 0, 0, 8, 8, 15)
			-- 	 end
			-- 	 b.set_background_pixmap(pixmap)
		end

	draw_box (d: DRAWABLE; x, y, width, height: INTEGER; intensity: INTEGER) is
		do
			pen.set_drawable(d)
			pen.set_color(color_gradient.item(intensity))
			pen.fill_rectangle(x, y, width, height)
		end

feature {}
	color_gradient: FAST_ARRAY[COLOR] is
			-- 17 levels from black(0) to white(16)
		local
			i: INTEGER; color: COLOR
		once
			create Result.make(17)
			from
				i := Result.upper
				create color.like_rgb_8(255, 255, 255)
				Result.put(color, i)
				i := i - 1
			until
				i < Result.lower
			loop
				create color.like_rgb_8(i * 16, i * 16, i * 16)
				Result.put(color, i)
				i := i - 1
			end
		end

end -- class BASIC_RENDERER
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
