-- See the Copyright notice at the end of this file.
--
deferred class STATE
	-- This class describe the state of widgets.

insert
	STATE_CONSTANTS

feature {ANY}
	state: INTEGER -- use values from STATE_CONSTANTS

	frozen is_state_normal: BOOLEAN is
		do
			Result := state = state_normal
		end

	frozen is_state_active: BOOLEAN is
		do
			Result := state = state_active
		end

	frozen is_state_prelight: BOOLEAN is
		do
			Result := state = state_prelight
		end

	frozen is_state_selected: BOOLEAN is
		do
			Result := state = state_selected
		end

	frozen is_state_insensitive: BOOLEAN is
		do
			Result := state = state_insensitive
		end

feature {}
	frozen set_state_normal is
		do
			set_state(state_normal)
		end

	frozen set_state_active is
		do
			set_state(state_active)
		end

	frozen set_state_prelight is
		do
			set_state(state_prelight)
		end

	frozen set_state_selected is
		do
			set_state(state_selected)
		end

	frozen set_state_insensitive is
		do
			set_state(state_insensitive)
		end

	set_state (n: INTEGER) is
		do
			state := n
		end

	renderer: RENDERER is
		once
			create {DEFAULT_RENDERER} Result
		end

end -- class STATE
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
