-- See the Copyright notice at the end of this file.
--
class VERTICAL_LINE
	-- `VERTICAL_LINE' is a widget you can use as separator. As it's
	-- a widget, position and size are managed by the layout
	-- associated with the container the line is put into.

inherit
	LINE
		redefine default_create
		end
	
creation {ANY}
	default_create

feature {}
	default_create is
		do
			width := 1
			height := 1
			thickness := 1
			y_expand_allowed := True
			std_height := 1
		end

feature {ANY}
	min_height: INTEGER is 1
			--TODO: change with thickness ?

	std_height: INTEGER

	std_width, min_width: INTEGER is
		do
			Result := thickness
		end

	set_thickness (thick: INTEGER) is
		do
			--TODO: influence width/position
			if thickness /= thick then
				thickness := thick
				if thick > width then
					--TODO: change this code
					width := thick
				end
				parent.child_requisition_changed
			end
		end

feature {LAYOUT}
	expose_paint is
		do
			if style /= Void then
				style.draw_line(parent.drawing_widget, pos_x, pos_y, pos_x, pos_y + height - 1)
			else
				renderer.draw_line(parent, pos_x, pos_y, pos_x, pos_y + height - 1, state)
			end
		end

end -- class VERTICAL_LINE
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
