-- See the Copyright notice at the end of this file.
--
class SUB_WINDOW

inherit
	WINDOW
		export {LAYOUT, SCROLL_VIEW} set_geometry
		redefine make_layout
		end

creation {ANY}
	make, make_layout, sub_window_create

feature {}
	make (p: like parent) is
		local
			default_layout: ROW_LAYOUT
		do
			create default_layout
			make_layout(p, default_layout)
		end

	make_layout (p: like parent; lo: LAYOUT) is
		do
			width := 1
			height := 1
			min_width := 1
			min_height := 1
			std_width := 1
			std_height := 1
			widget := basic_window_create(0, 0, width, height, p.widget, False)
			container_init
			p.child_attach(Current)
			vision.register(Current)
			default_init
			layout := lo
			lo.set_container(Current)
		end

	sub_window_create (x, y, w, h: INTEGER; parent_window: WINDOW) is
		require
			x.in_range(0, parent_window.width - 1)
			y.in_range(0, parent_window.height - 1)
			w.in_range(1, parent_window.width - x)
			h.in_range(1, parent_window.height - y)
		do
			--TODO: std_width, min_width...
			width := w
			height := h
			widget := basic_window_create(x, y, width, height, parent_window.widget, False)
			vision.register(Current)
		end

end -- class SUB_WINDOW
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
