/*
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
*/
#ifdef WIN32
/*#  include <windows.h> done in base.h */
#  ifndef _MSC_VER
#    include <winsock2.h>
#  endif
   extern int win32_msg;
   extern int win32_msg_ready;
   extern HANDLE sem_msg_ready;
#else
#  include <sys/time.h>
/*#  include <unistd.h> done in base.h */
/*#  include <sys/types.h> done in base.h */
#endif

#ifdef WIN32
#  define basic_file_watch(set, fd) do { \
  if ((fd)==-1) win32_msg=1; else FD_SET((SOCKET)fd, (fd_set*)(set)); \
} while(0)
#else
#  define basic_file_watch(set, fd) FD_SET(fd, (fd_set*)(set))
#endif


#ifdef WIN32
#  define basic_file_is_ready(set, fd) (EIF_BOOLEAN)(((fd)==-1)?win32_msg_ready:FD_ISSET(fd, (fd_set*)(set)))
#else
#  define basic_file_is_ready(set, fd) FD_ISSET(fd, (fd_set*)(set))
#endif


#ifdef WIN32
#  define basic_file_reset(set) do{win32_msg=0;win32_msg_ready=FALSE;FD_ZERO((fd_set*)(set));}while(0)
#else
#  define basic_file_reset(set) FD_ZERO((fd_set*)(set))
#endif

#define basic_file_create_set (_basic_file_create_set())
EIF_POINTER _basic_file_create_set(void);
int basic_file_wait(int n, fd_set *read_set, int read_size, fd_set *write_set, int write_size, int s, int us);

#define basic_file_descriptor(file) (fileno(file))
