/*
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
*/
void *basic_font_new(char *font_name){
#ifdef WIN32
  /* --TODO: font creation */
  return (void *)GetStockObject(SYSTEM_FONT);
#else
  return (void *)XLoadFont (dpy, font_name);
#endif
}


int basic_font_exist(void * desc){
#ifdef WIN32
  printf("Not yet implemented, file=%s, line=%d\n",__FILE__,__LINE__);
  exit(0);
  return 0;
#else
  char ** N;int v;
  N = XListFonts(dpy, desc, 1,&v);
  XFreeFontNames(N);
  return N != NULL;
#endif
}

void * basic_font_properties(void * font_id){
  /* --TODO: memory management */
#ifdef WIN32
  TEXTMETRIC *tm = malloc(sizeof(TEXTMETRIC));

  /* --TODO: optimize ! */
  HDC hdc = CreateCompatibleDC(NULL);
  SelectObject(hdc, (HFONT)font_id);
  GetTextMetrics(hdc, tm);
  DeleteDC(hdc);

  return tm;
#else
  return XQueryFont(dpy,(Font)font_id);
#endif
}

int basic_font_height(void *f){
#ifdef WIN32
  return ((TEXTMETRIC *)f)->tmHeight+((TEXTMETRIC *)f)->tmExternalLeading;
#else
  /* --TODO: use XFontStruct fields ?*/
  int a,b,c;XCharStruct xcs;
  XTextExtents((XFontStruct*)f,"ff",2,&a,&b,&c,&xcs); /* --TODO:CHECK the text */
  return b+c;
#endif
}

int basic_font_ascent(void *f){
#ifdef WIN32
  return ((TEXTMETRIC *)f)->tmAscent+((TEXTMETRIC *)f)->tmExternalLeading;
#else
  /* --TODO: use field ascent */
  int a,b,c;XCharStruct xcs;
  XTextExtents((XFontStruct*)f,"",0,&a,&b,&c,&xcs);
  return b;
#endif
}

int basic_font_text_width(void *f, void * font_id, void *str, int size){
#ifdef WIN32
  SIZE res;
  /* --TODO: optimize ! */
  HDC hdc = CreateCompatibleDC(NULL);
  SelectObject(hdc, (HFONT)font_id);
  GetTextExtentPoint32W(hdc, str, size, &res);
  DeleteDC(hdc);

  return res.cx;
#else
#  if BYTE_ORDER == BIG_ENDIAN
  return XTextWidth16((XFontStruct*)f, str, size);
#  else
  static uint16_t swap_buffer[1024];
  copy_swap_16(str, swap_buffer, (size>1024)?1024:size);
  return XTextWidth16((XFontStruct*)f, (XChar2b*)swap_buffer, size);
#  endif
#endif
}
