/*
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
*/
void basic_guikit_point(XPoint* out, int x, int y) {
  out->x = (short)x;
  out->y = (short)y;
}

void basic_guikit_arc(XArc* out, int x, int y, int width, int height, int angle1, int angle2) {
  out->x = (short)x;
  out->y = (short)y;
  out->width  = (unsigned int)width;
  out->height = (unsigned int)height;
  out->angle1 = angle1;
  out->angle2 = angle2;
}

static void basic_guikit_translate_points(void* points, int npoints, int dx, int dy) {
  int i;
  XPoint* p = ((XPoint*)points) + npoints;
  if (dx != 0 || dy != 0) {
    for (i = npoints; i --> 0;) {
      --p;
      p->x += dx;
      p->y += dy;
    }
  }
}

static void basic_guikit_translate_arcs(void* arcs, int narcs, int dx, int dy) {
  int i;
  XArc* p = ((XArc*)arcs) + narcs;
  if (dx != 0 || dy != 0) {
    for (i = narcs; i --> 0;) {
      --p;
      p->x += dx;
      p->y += dy;
    }
  }
}

void basic_guikit_drawlines(void* peer, void* points, int npoints, int dx, int dy) {
  /* Beware X server max request size! */

  basic_guikit_translate_points(points, npoints, dx, dy);
  XDrawLines(dpy, (Drawable)peer, DefaultGC(dpy, DefaultScreen(dpy)), (XPoint*)points, npoints, CoordModeOrigin);
}

void basic_guikit_fillpolygon(void* peer, void* points, int npoints, int dx, int dy) {
  /* Beware X server max request size! */

  basic_guikit_translate_points(points, npoints, dx, dy);
  XFillPolygon(dpy, (Drawable)peer, DefaultGC(dpy, DefaultScreen(dpy)), (XPoint*)points, npoints, Complex, CoordModeOrigin);
}

void basic_guikit_drawarcs(void* peer, void* arcs, int narcs, int dx, int dy) {
  /* Beware X server max request size! */

  basic_guikit_translate_arcs(arcs, narcs, dx, dy);
  XDrawArcs(dpy, (Drawable)peer, DefaultGC(dpy, DefaultScreen(dpy)), (XArc*)arcs, narcs);
}

void basic_guikit_fillarcs(void* peer, void* arcs, int narcs, int dx, int dy) {
  /* Beware X server max request size! */

  basic_guikit_translate_arcs(arcs, narcs, dx, dy);
  XFillArcs(dpy, (Drawable)peer, DefaultGC(dpy, DefaultScreen(dpy)), (XArc*)arcs, narcs);
}

