/*
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
*/
#define basic_guikit_point_size sizeof(XPoint)
#define basic_guikit_arc_size sizeof(XArc)

#define basic_guikit_point_get_x(point) (((point)==NULL) ? 0 : ((XPoint*)point)->x)
#define basic_guikit_point_get_y(point) (((point)==NULL) ? 0 : ((XPoint*)point)->y)

#define basic_guikit_arc_get_x(arc)      (((arc)==NULL) ? 0 : ((XArc*)arc)->x)
#define basic_guikit_arc_get_y(arc)      (((arc)==NULL) ? 0 : ((XArc*)arc)->y)
#define basic_guikit_arc_get_width(arc)  (((arc)==NULL) ? 0 : ((XArc*)arc)->width)
#define basic_guikit_arc_get_height(arc) (((arc)==NULL) ? 0 : ((XArc*)arc)->height)
#define basic_guikit_arc_get_angle1(arc) (((arc)==NULL) ? 0 : ((XArc*)arc)->angle1)
#define basic_guikit_arc_get_angle2(arc) (((arc)==NULL) ? 0 : ((XArc*)arc)->angle2)

extern void basic_guikit_point(XPoint* out, int x, int y);
extern void basic_guikit_arc(XArc* out, int x, int y, int width, int height, int angle1, int angle2);

extern void basic_guikit_drawlines(void* peer, void* points, int npoints, int dx, int dy);
extern void basic_guikit_fillpolygon(void* peer, void* points, int npoints, int dx, int dy);
extern void basic_guikit_drawarcs(void* peer, void* arcs, int narcs, int dx, int dy);
extern void basic_guikit_fillarcs(void* peer, void* arcs, int narcs, int dx, int dy);

