class CONNECTION
--
-- Handle one connection to the MULTIPLEX_SERVER
--
inherit
	JOB

create {MULTIPLEX_SERVER}
	make

feature {LOOP_ITEM}
	prepare (ready: READY_DESCRIPTION) is
		do
			ready.when_data(ios)
		end

	is_ready (ready: READY_DESCRIPTION): BOOLEAN is
		do
			Result := ready.is_data(ios)
		end

	continue is
		local
			s: STRING
		do
			ios.read_line
			s := ios.last_string
			if not s.is_empty then
				io.put_string(s)
				io.put_new_line
				if s.same_as(once "stop") then
					ios.disconnect
					done := True
				end
			end
		end

	done: BOOLEAN

	restart is
		do
			-- cannot restart a connection
			--*** (the postcondition will not be respected, how can I do otherwise? Philippe?)
		end

feature {}
	make(a_io: like ios) is
		do
			io.put_string(once "(new connection accepted)%N")
			a_io.unset_timeout
			ios := a_io
		end

	ios: SOCKET_INPUT_OUTPUT_STREAM
end
